/*This is the program used to evaluate the value of the function & errors
Zdt 2,3,4 have been coded, in the menu of the program, type in 2-zdt2, 3-zdt3, 4 for zdt4 or 0 for your own function
************************************************************************/
#include<math.h>
#define pi 3.1416

void func(population *pop_ptr);

void func(population *pop_ptr)
{
//variables for calculation of zdt problems
float gx=0.0,gxtemp=0.0;


  /*File ptr to the file to store the value of the g for last iteration
    g is the parameter required for a particular problem
    Every problem is not required*/
 
  float *realx_ptr, /*Pointer to the array of x values*/
    *binx_ptr,      /* Pointer to the binary variables */
    *fitn_ptr,      /*Pointer to the array of fitness function*/
    x[2*maxvar],     /* problem variables */
    f[maxfun],     /*array of fitness values*/
    *err_ptr,      /*Pointer to the error */
    cstr[maxcons];

  int i,j,k;
  float error, cc;

  pop_ptr->ind_ptr= &(pop_ptr->ind[0]);

  /*Initializing the max rank to zero*/
  pop_ptr->maxrank = 0;
  for(i = 0;i < popsize;i++)
    {
      pop_ptr->ind_ptr = &(pop_ptr->ind[i]);
      realx_ptr = &(pop_ptr->ind_ptr->xreal[0]);
      binx_ptr = &(pop_ptr->ind_ptr->xbin[0]);
	if(zdt==4)
	    gx=1+10*(nchrom+nvar-1);  
	else if(zdt==3 || zdt==2)
		gx=1;
      for(j = 0; j < nvar; j++)
	{ // Real-coded variables 
	  x[j] = *realx_ptr++;
	}
	
      for(j = 0; j < nchrom; j++)
	{ // Binary-codced variables

	  x[nvar+j] = *binx_ptr++;
		
	}
      for(j=0;j<nvar+nchrom;j++)
		{
		if(j>0)
			if(zdt==4)
				gx=gx+(x[j]*x[j])-10*cos(4*pi*x[j]);	
			else if(zdt==3 || zdt==2)
				gxtemp=gxtemp+x[j];
		}
		if(zdt==3 || zdt==2)
			gx=gx+gxtemp*(9/(nvar+nchrom-1));
      fitn_ptr = &(pop_ptr->ind_ptr->fitness[0]);
      err_ptr = &(pop_ptr->ind_ptr->error);



      /*   DO NOT CHANGE ANYTHING ABOVE   */
      

	if(zdt==0)
	{
	/*----------------------CODE YOUR OBJECTIVE FUNCTIONS HERE------------*/
      /*All functions must be of minimization type, negate maximization
            functions */
      /*============Start Coding Your Function From This Point=============*/
    // First fitness function
	f[0]=x[0];
	// Second fitness function
	f[1]=x[1];
	}
	else if (zdt==4)
	{
      f[0] = x[0];

      f[1] = gx*(1-sqrt(x[0]/gx));
	}
	else if(zdt==3)
	{
      f[0] = x[0];

      f[1] = gx*(1-sqrt(x[0]/gx)-(x[0]/gx)*sin(10*pi*x[0]));
	}
	else if(zdt==2)
	{
      f[0] = x[0];

      f[1] = gx*(1-(x[0]*x[0]/(gx*gx)));
	}	
	funeval++;
      /*=========End Your Coding Upto This Point===============*/

      /******************************************************************/
      /*              Put The Constraints Here                          */
      /******************************************************************/
      // g(x) >= 0 type (normalize g(x) as in the cstr[1] below)
      /*===========Start Coding Here=============*/
      /*
      cstr[0] = x[0];
      cstr[1] = 1-x[0];
		for(j=2;j<ncons;j+=2)
      	{
			cstr[j]=x[j/2]+5;
			cstr[j+1]=5-x[j/2];
		}*/
      /*===========Constraints Are Coded Upto Here=============*/
      /*   DO NOT CHANGE ANYTHING BELOW  */



      for(k = 0 ; k < nfunc ;k++)
	{
	  *fitn_ptr++  = f[k];
	}
      
      for (k = 0;k < ncons; k++)
	{
	  pop_ptr->ind_ptr->constr[k] = cstr[k];
	}
      error = 0.0;
      for (k = 0;k < ncons;k++)
	{
	  cc = cstr[k];
	  if(cc < 0.0)
	    error = error - cc;
	}
      *err_ptr = error;
    }
  
  /*---------------------------* RANKING *------------------------------*/
  
  if(ncons == 0)
    ranking(pop_ptr);
  else
    rankcon(pop_ptr);

  return;
}






