/* This is the module used to formulate the mutation routine*/

void realjgtype(population *new_pop_ptr);        
void real_jg(population *new_pop_ptr);             
void real_ajg(population *new_pop_ptr);             

void realjgtype(population *new_pop_ptr)
{
 
	if(rjgtype==1)
		real_jg(new_pop_ptr);
	else if(rjgtype==2)
		real_ajg(new_pop_ptr);
	else
  		return ;
}


void real_jg(population *new_pop_ptr)
{
  int i,j,r,p,q,swap;
  float rnd,randp,randq,delta,indi,*ptr,*ptr1,deltaq;
  float y,yl,yu,val,xy;
  prealjg=0.5;		//probability of applying jg operator on the population
  for(j = 0;j < popsize;j++)
    {
		rnd = randomperc();
		if(rnd<prealjg)
		{
			nmutjg++;
			randp=randomperc()*nvar;
			randq=randomperc()*nvar;
			p=randp;
			q=randq;
			if(q<p)
			{
				swap=q;
				q=p;
				p=swap;
			}
			else if(q==p && p!=nvar)
				q=p+1;
	    	for (i = p;i < q; i++)
		{
	   		y = new_pop_ptr->ind[j].xreal[i];
	      		yl = lim_r[i][0];
	      		yu = lim_r[i][1];
	      		y=yl+(randomperc())*(yu-yl);
	      
		  	new_pop_ptr->ind[j].xreal[i] = y;
				
		}
		}
	}
    
  return ;
}

void real_ajg(population *new_pop_ptr)
{
  int i,j,r,p,swap;
  float rnd,randp,indi,*ptr,*ptr1;
  float y,yl,yu,val,xy;
	prealjg=0.5;	//probability of applying ajg operator on the population
	realfb=15;	//change fb according to the problem
  for(j = 0;j < popsize;j++)
    {
		rnd = randomperc();
		if(rnd<prealjg)
		{
			randp=randomperc()*(nvar-realfb);
			p=randp;
			nmutjg++;
			for (i = p;i < p + realfb ; i++)
			{
	   		y = new_pop_ptr->ind[j].xreal[i];
	      		yl = lim_r[i][0];
	      		yu = lim_r[i][1];
	      		y=yl+(randomperc())*(yu-yl);
	      
		  	new_pop_ptr->ind[j].xreal[i] = y;
				
		    }
		}
	}
    
  return ;
}
