#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#define maxpop 400	//maximum no of solutions in the final output file
#define maxfunc 20
#define MAXFILES 10	//no of output files compared

/*
The input files ie jg.out,ajg.out and so on were renamed from the file final_fitness.out after testing each form of jg with nsga2.c
The upper 2 lines of these files were also deleted
Usage for linux: gcc matrix.c -lm
		./a.out
*/
float finalfitp[maxpop][maxfunc];
float finalfitq[maxpop][maxfunc];
int func,pop,files;
FILE *file[MAXFILES];

float metric(int , int);

main()
{

int i,j,k;
float returned[MAXFILES][MAXFILES];  

do{
	printf("\n Enter no of objective functions(<%d): ",maxfunc);
	scanf("%d",&func);
}while(func>maxfunc);
do{
	printf("\n Enter population size(<%d): ",maxpop);
	scanf("%d",&pop);
}while(func>maxfunc);
do{
	printf("\n Enter The number of files(<%d)(You can set their names in the function metric(int,int)): ",MAXFILES);
	scanf("%d",&files);
}while(files>MAXFILES);
printf("\nSet Coverage Metric for the ZDT4 problem");
printf("\nJG\t\tAJG\t\tSAJG\t\tSJG\t\tRealJG\t\tRealaJG\n");
for(i=0;i<files;i++)
{
	for(j=0;j<files;j++)
		{
			if(i!=j)
				{
				returned[i][j]=(metric(i,j)/pop);
				printf("%f\t",returned[i][j]);
				}
			else
				{
				returned[i][j]=0;
				printf("-\t\t");
				}
		}
		printf("\n");
}


for(i=0;i<files;i++)
	fclose(file[i]);

}


float metric(int f1,int f2)
{
	int p,q,i,j,k;
	int dominates,dominated,flagdd=0,flagds=0;
	float fraction=0;
//set the names of the files you want in the matrix
file[0] = fopen("jg.out","r");
file[1] = fopen("ajg.out","r");
file[2] = fopen("sajg.out","r");
file[3] = fopen("sjg.out","r");
file[4] = fopen("realjg.out","r");
file[5] = fopen("realajg.out","r");
	for(i=0;i<pop;i++)
	{
		for(j=0;j<func;j++)
		{
			fscanf(file[f1],"%f",&finalfitp[i][j]);
			fscanf(file[f2],"%f",&finalfitq[i][j]);
			//printf("%f  %f",finalfitp[i][j],finalfitq[i][j]);
		}
	}
	for(p=0;p<pop;p++)
	{

		flagds=0;
		flagdd=0;
		for(q=0;q<pop;q++)
		{
			dominated=0;
			dominates=0;
			for(j=0;j<func;j++)
			{
				if(finalfitp[p][j] > finalfitq[q][j])
				{
					dominated++;
					//printf("\ndd\t%f\t%f\t%d",finalfitp[p][j],finalfitq[q][j],dominated);
				}
				else
				{
					dominates++;
					//printf("\nds%f\t%f\t%d",finalfitp[p][j],finalfitq[q][j],dominates);
					
				}
			}
			if(dominates==func)
				flagds=1;
			if(dominated==func)
				flagdd=1;
	
		}
		if(flagds==1 && flagdd==0)
			fraction++;

	}	
	return (fraction);

}


