/* Added 5 Different type of Jumping Gene Mutation Operators,  If any of their parameters are needed to be changed, the changes are to be made in this file.
*/    
void binjgtype(population *new_pop_ptr);      
void jg(population *new_pop_ptr);
void ajg(population *new_pop_ptr);
void mjg(population *new_pop_ptr);
void sajg(population *new_pop_ptr);
void sjg(population *new_pop_ptr);


void binjgtype(population *new_pop_ptr)
{
	if(bjgtype==1)
		jg(new_pop_ptr);
	else if (bjgtype==2)
		ajg(new_pop_ptr);
	else if (bjgtype==3)
		mjg(new_pop_ptr);
	else if (bjgtype==4)
		sajg(new_pop_ptr);
	else if (bjgtype==5)
		sjg(new_pop_ptr);
	else
  		return;
}

void jg(population *new_pop_ptr)
{
  int i,*ptr,j,r;
  float randjg;
  float randp,randq,randbit;
  int p,q,swap;

  pjg=0.5;		//probability of jg operator occuring for a particular chromosome
  new_pop_ptr->ind_ptr = &(new_pop_ptr->ind[0]);
  
	for(j = 0;j < popsize;j++)
	{
		randjg=randomperc();
		ptr= &(new_pop_ptr->ind_ptr->genes[0]);
    		new_pop_ptr->ind_ptr =&(new_pop_ptr->ind[j+1]);     


		if(randjg<=pjg)
		{
			//select end and starting locations, p and q
			nmutjg++;
			randp=randomperc()*chrom;
			p=randp;
			randq=randomperc()*chrom;
			q=randq;
			//printf("\n pq, %d, %d",p,q);
			if(p>q)
			{
				swap=q;
				q=p;
				p=swap;
			}
			else if(p==q)
			{	
				q=p+1;
			}
			for (i=0 ; i < p ; i++)
			{
				ptr++;
			}
	   	 	for (i = p ; i < q ; i++)
			{
	  
	  			randbit=randomperc();
	  			if(randbit <= 0.5)
					*ptr =1;
		      	else
					*ptr=0;
		      	
		    	
			ptr++;
			}
    		}
	}
  return;
}


void ajg(population *new_pop_ptr)
{

  int i,*ptr,j,r;
  float randjg;
  float randp,randbit;
  int p;
  pajg=0.5;
  fb=25;		//no of fixed bits that will be changed according to the ajg operator
  	new_pop_ptr->ind_ptr = &(new_pop_ptr->ind[0]);
  
	for(j = 0;j < popsize;j++)
	{
		randjg=randomperc();
		ptr= &(new_pop_ptr->ind_ptr->genes[0]);
    		new_pop_ptr->ind_ptr =&(new_pop_ptr->ind[j+1]);     
  		
  	        /*Select bit */
		if(randjg<=pajg)
		{
			nmutjg++;
			randp=randomperc()*(chrom-fb);
			p=randp;
			
			for (i=0 ; i < p ; i++)
			{
				ptr++;
			}
	   	 	for (i = p ; i < p + fb ; i++)
			{
	  
	  			randbit=randomperc();
	  			if(randbit <= 0.5)
					*ptr =1;
		      	else
					*ptr=0;
		      	
		    	
			ptr++;
			}
    		}
	}
  return;
}


void mjg(population *new_pop_ptr)
{
//works best when the optimal solution contains the upper or lower bound values
int i,*ptr,j,r;
float randjg;
float randbit;
int p;
int temp;
pmjg=0.5;
			
	new_pop_ptr->ind_ptr = &(new_pop_ptr->ind[0]);
  	for(j = 0;j < popsize;j++)
	{
		
	   	ptr= &(new_pop_ptr->ind_ptr->genes[0]);
    		new_pop_ptr->ind_ptr =&(new_pop_ptr->ind[j+1]);     
  		randjg = randomperc();
	        /*Select bit */
		if(randjg<=pmjg)
		{
			nmutjg++;
			p=randomperc()*(nchrom);
			//temp=0;
			for (i=0 ; i < p ; i++)
			{
				ptr+=vlen[i];
				//temp+=vlen[i];
			}
			//printf("\nat %d,",temp);
			randbit=randomperc();
	   	 	for (i = 0 ; i < vlen[p] ; i++)
			{
	  
	  			
	  			if(randbit <= 0.5)
					*ptr =1;
		      	else
					*ptr=0;
		      	
		    	//printf("%d",*ptr);
			ptr++;
			}
			
    		}
	}
  return;
}

void sajg(population *new_pop_ptr)
{

  int i,*ptr,j,r;
  float randjg;
  float randp,randbit;
  int p;
  psajg=0.75;
  fbb=vlen[0];		//value of one complete variable is changed

  new_pop_ptr->ind_ptr = &(new_pop_ptr->ind[0]);
  
	for(j = 0;j < popsize;j++)
	{
		randjg=randomperc();
		ptr= &(new_pop_ptr->ind_ptr->genes[0]);
    		new_pop_ptr->ind_ptr =&(new_pop_ptr->ind[j+1]);     
  		
 	        /*Select bit */
		if(randjg<=psajg)
		{
			nmutjg++;
			randp=randomperc()*(chrom-fbb);
			p=randp;
			
			for (i=0 ; i < p ; i++)
			{
				ptr++;
			}
	   	 	for (i = p ; i < p + fbb ; i++)
			{
	  
	  			randbit=randomperc();
	  			if(randbit <= 0.5)
					*ptr =1;
		      	else
					*ptr=0;
		      	
		    	
			ptr++;
			}
    		}
	}
  return;
}

void sjg(population *new_pop_ptr)
{

  int i,*ptr,j,r;
  float randjg;
  float randbit;
  int a;
  int temp;
  psjg=0.6;
  
	new_pop_ptr->ind_ptr = &(new_pop_ptr->ind[0]);
  
	for(j = 0;j < popsize;j++)
	{
			
	 	ptr= &(new_pop_ptr->ind_ptr->genes[0]);
    		new_pop_ptr->ind_ptr =&(new_pop_ptr->ind[j+1]);     
  		randjg = randomperc();
      		/*Select bit */
		if(randjg<=psjg)
		{
			nmutjg++;
			a=randomperc()*(nchrom);
			//temp=0;
			for (i=0 ; i < a ; i++)
			{
				ptr+=vlen[i];
				//temp+=vlen[i];
			}
			//printf("\nat %d,",temp);
			
			fbbb=vlen[a];
	   	 	for (i = 0 ; i < fbbb ; i++)
			{
	  
	  			randbit=randomperc();
	  			if(randbit <= 0.5)
					*ptr =1;
		      	else
					*ptr=0;
		      	
		    	//printf("%d",*ptr);
			ptr++;
			}
			
    		}
	}
  return;
}


